accounts/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView
from accounts.views import register

urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("signup/", register, name="signup"),
]

projects/urls.py
from django.urls import path
from projects.views import (
    ProjectListView,
    ProjectDetailView,
    ProjectCreateView,
)

urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
]

tasks/urls.py
from django.urls import path
from tasks.views import TaskCreateView, TaskListView, TaskUpdateView

urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
    path("<int:pk>/complete/", TaskUpdateView.as_view(), name="complete_task"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import RedirectView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path("accounts/", include("accounts.urls")),
    path("tasks/", include("tasks.urls")),
    path("", RedirectView.as_view(url=("/projects/")), name="home"),
]

accounts/models.py
# from django.db import models

# Create your models here.

projects/models.py
from django.db import models
from django.conf import settings

auth_USER = settings.AUTH_USER_MODEL


class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(auth_USER, related_name="projects")

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models
from django.conf import settings


auth_USER = settings.AUTH_USER_MODEL


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField(auto_now=False, auto_now_add=False)
    due_date = models.DateTimeField(auto_now=False, auto_now_add=False)
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project", related_name="tasks", on_delete=models.CASCADE
    )
    assignee = models.ForeignKey(
        auth_USER, related_name="tasks", on_delete=models.SET_NULL, null=True
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect

from accounts.form import UserRegistrationForm
from django.contrib.auth import authenticate, login


def register(request):
    if request.method == "POST":
        form = UserRegistrationForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data.get("username")
            password = form.cleaned_data.get("password1")
            form.save()
            user = authenticate(username=username, password=password)
            if user is not None:
                login(request, user)
                return redirect("home")
    form = UserRegistrationForm()
    context = {"form": form}
    return render(request, "registration/signup.html", context)

projects/views.py
from projects.models import Project
from django.urls import reverse
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
from django.contrib.auth.mixins import LoginRequiredMixin


class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "projects/new.html"
    fields = ["name", "description", "members"]

    def get_success_url(self):
        return reverse("show_project", kwargs={"pk": self.object.pk})

tasks/views.py
from django.shortcuts import redirect
from django.urls import reverse_lazy
from django.views.generic.edit import CreateView, UpdateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from tasks.models import Task


class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks/new.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]

    def form_valid(self, form):
        task = form.save(commit=False)
        task.members = self.request.user
        task.save()
        return redirect("show_project", pk=task.project.id)


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/list.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)


class TaskUpdateView(LoginRequiredMixin, UpdateView):
    model = Task
    fields = ["is_completed"]
    success_url = reverse_lazy("show_my_tasks")

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)

projects/templates/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>Document</title>
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    {% if user.is_authenticated %}
                        <li><a href="{% url "show_my_tasks" %}">My tasks</a></li>
                        <li><a href="{% url "list_projects"%}">My projects</a></li>
                        <li><a href="{% url "logout" %}">Logout</a></li>
                    {% else %}
                        <li><a href="{% url "login" %}">Login</a></li>
                        <li><a href="{% url "signup" %}">Signup</a></li>
                    {% endif %}
                </ul>
            </nav>
        </header>
        {% block content %} {% endblock content %}
    </body>
</html>

projects/templates/projects/detail.html
{% extends 'base.html' %}
{% load markdownify %}
{% block content %}
    <main>
        <div>
            <h1>{{project.name}}</h1>
            {{ project.description|markdownify }}
            <h2>Tasks</h2>
            <p><a href="{% url "create_task" %}">Create a new task</a></p>
            {% if project.tasks.all %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Assignee</th>
                            <th>Start date</th>
                            <th>Due date</th>
                            <th>Is completed</td>
                        </tr>
                    </thead>
                    <tbody>
                        {% for task in project.tasks.all %}
                            <tr>
                                <td>{{task.name}}</td>
                                <td>{{task.assignee}}</td>
                                <td>{{task.start_date|date:"M,d,Y"}}</td>
                                <td>{{task.due_date|date:"M,d,Y"}}</td>
                                <td>{{task.is_completed|yesno:"Yes,No"}}</td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            {% else %}
                <p>This project has no tasks</p>
            {% endif %}
        </div>
    </main>
{% endblock content %}

projects/templates/projects/list.html
{% extends 'base.html' %}
{% block content %}
    <main>
        <div>
            <h1>My Projects</h1>
            <p><a href="{% url "create_project" %}">Create a new project</a></p>
            {% if not project_list %}
                <p>You are not assigned to any projects</p>
            {% else %}
                <table>
                    <thead>
                        <td>Name</td>
                        <td>Number of tasks</td>
                    </thead>
                    {% for project in project_list %}
                        <tbody>
                            <tr>
                                <td><a href="{% url "show_project" project.pk %}">{{project.name}}</a></td>
                                <td>{{project.tasks.all|length}}</td>
                            </tr>
                        </tbody>
                    {% endfor %}
                </table>
            {% endif %}
        </div>
    </main>
{% endblock content %}

projects/templates/projects/new.html
{% extends 'base.html' %} {% block content %}
    <main>
        <div>
            <h1>Create a new project</h1>
            <form method="post">
                {% csrf_token %}{{form.as_p}}
                <button>Create</button>
            </form>
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/list.html
{% extends 'base.html' %}
{% block content %}
    <main>
        <div>
            <h1>My Tasks</h1>
            {% if task_list %}
                <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Start date</th>
                            <th>End date</th>
                            <th>is completed</td>
                        </tr>
                    </thead>
                    {% for task in task_list %}
                        <tbody>
                            <tr>
                                <td>{{task.name}}</td>
                                <td>{{task.start_date|date:"M,d,Y"}}</td>
                                <td>{{task.due_date|date:"M,d,Y"}}</td>
                                <td>{{task.is_completed|yesno:"Done,"}}
                                    {% if not task.is_completed %}
                                        <form method="post" action="{% url "complete_task" task.id%}">
                                            {% csrf_token %}
                                            <input type="hidden" name="is_completed" value="True">
                                            <button>Complete</button>
                                        </form>
                                    {% endif %}
                                </td>
                            </tr>
                        </tbody>
                    {% endfor %}
                </table>
            {% else %}
                <p>You have no tasks</p>
            {% endif %}
        </div>
    </main>
{% endblock content %}

tasks/templates/tasks/new.html
{% extends 'base.html' %} {% block content %}
    <main>
        <div>
            <h1>Create a new task</h1>
            <form method="post">
                {% csrf_token %}{{form.as_p}}
                <button>Create</button>
            </form>
        </div>
    </main>
{% endblock content %}